#!/bin/sh
######################################################################
# createapptables.sh

# Wrapper script for createapptables.sql so it can find the current
# directory and, thus, the path to the included file

# Usage:

#     createapptables.sh database [ dbuser ]
######################################################################
# Copyright 2011 Theodore B. Ruegsegger
# This file is part of the PhotoTrove web application.

# PhotoTrove is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# PhotoTrove is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
######################################################################
if [ $# -lt 1 ]
then
    echo Usage: createapptables.sh database [ dbuser ]
    exit
else
    Database=$1
    if [ $# -gt 1 ]
    then
	DbUser=$2
    else
	DbUser=$(echo $Database | sed -e 's/_.*$//')
    fi
fi

if echo $0 | grep '/' >/dev/null
then
    LocalDir=$(echo $0 | rev | cut -d '/' -f 2- | rev)
else
    LocalDir=$(pwd)
fi

StartDir=$(pwd)
cd $LocalDir

psql -q -d $Database -U $DbUser -f createapptables.sql 2>&1 \
    | grep -v 'NOTICE:'

cd $StartDir
