#!/bin/sh
######################################################################
# findmissingpics.sh

# Identifies photos that exist in database but for which there are no
# actual image files.

######################################################################
# Copyright 2014 Theodore B. Ruegsegger
# This file is part of the PhotoTrove web application.

# PhotoTrove is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# PhotoTrove is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
######################################################################

# Usage: findmissingpics.sh
######################################################################
DbUser=foto
Database=foto
Fulls=/home/web/webroot-ssl/foto/fullsize
######################################################################
Query="psql -d $Database -U $DbUser"

Q="SELECT foldername FROM photoset ORDER BY foldername"
Folders=$($Query -tc "$Q")
M=""
for Folder in $Folders
do
    Q="SELECT filename FROM photo WHERE foldername = '$Folder'"
    Q="$Q ORDER BY filename"
    Files=$($Query -tc "$Q")
    echo Checking $Folder
    for File in $Files
    do
	if [ ! -e $Fulls/$Folder/$File ]
	then
	    M="$M $Folder/$File"
	fi
    done
done
for Pic in $M
do
    echo $Pic
done > missingpics.txt
less missingpics.txt
