-- Database generated with pgModeler (PostgreSQL Database Modeler).
-- pgModeler  version: 0.9.1
-- PostgreSQL version: 9.6
-- Project Site: pgmodeler.io
-- Model Author: ---


-- Database creation must be done outside a multicommand file.
-- These commands were put in this file only as a convenience.
-- -- object: gapp | type: DATABASE --
-- -- DROP DATABASE IF EXISTS gapp;
-- CREATE DATABASE gapp;
-- -- ddl-end --
-- 

-- object: public.person | type: TABLE --
-- DROP TABLE IF EXISTS public.person CASCADE;
CREATE TABLE public.person(
	personsn serial NOT NULL,
	lastname text NOT NULL,
	firstname text,
	email text,
	phone text,
	CONSTRAINT person_pk PRIMARY KEY (personsn)

);
-- ddl-end --
-- ALTER TABLE public.person OWNER TO postgres;
-- ddl-end --

-- object: person_lastname | type: INDEX --
-- DROP INDEX IF EXISTS public.person_lastname CASCADE;
CREATE INDEX person_lastname ON public.person
	USING btree
	(
	  lastname
	);
-- ddl-end --

-- object: person_firstname | type: INDEX --
-- DROP INDEX IF EXISTS public.person_firstname CASCADE;
CREATE INDEX person_firstname ON public.person
	USING btree
	(
	  firstname
	);
-- ddl-end --

-- object: public.privilege | type: TABLE --
-- DROP TABLE IF EXISTS public.privilege CASCADE;
CREATE TABLE public.privilege(
	privilegesn serial NOT NULL,
	privname text NOT NULL,
	description text,
	CONSTRAINT privilege_pk PRIMARY KEY (privilegesn),
	CONSTRAINT privilege_privname UNIQUE (privname)

);
-- ddl-end --
-- ALTER TABLE public.privilege OWNER TO postgres;
-- ddl-end --

-- object: public.report | type: TABLE --
-- DROP TABLE IF EXISTS public.report CASCADE;
CREATE TABLE public.report(
	reportsn serial NOT NULL,
	name text NOT NULL,
	dispord integer,
	description text,
	CONSTRAINT report_pk PRIMARY KEY (reportsn),
	CONSTRAINT report_name UNIQUE (name)

);
-- ddl-end --
-- ALTER TABLE public.report OWNER TO postgres;
-- ddl-end --

-- object: public.tool | type: TABLE --
-- DROP TABLE IF EXISTS public.tool CASCADE;
CREATE TABLE public.tool(
	toolsn serial NOT NULL,
	name text NOT NULL,
	dispord integer,
	description text,
	CONSTRAINT tool_pk PRIMARY KEY (toolsn),
	CONSTRAINT tool_name UNIQUE (name)

);
-- ddl-end --
-- ALTER TABLE public.tool OWNER TO postgres;
-- ddl-end --

-- object: public.dbversion | type: TABLE --
-- DROP TABLE IF EXISTS public.dbversion CASCADE;
CREATE TABLE public.dbversion(
	dbversion text NOT NULL,
	CONSTRAINT dbversion_pk PRIMARY KEY (dbversion)

);
-- ddl-end --
-- ALTER TABLE public.dbversion OWNER TO postgres;
-- ddl-end --

-- object: public.reguser | type: TABLE --
-- DROP TABLE IF EXISTS public.reguser CASCADE;
CREATE TABLE public.reguser(
	regusersn serial NOT NULL,
	userid text NOT NULL,
	personsn integer NOT NULL,
	passwd_hash text,
	passwd_changed timestamp,
	CONSTRAINT reguser_pk PRIMARY KEY (regusersn),
	CONSTRAINT reguser_userid UNIQUE (userid)

);
-- ddl-end --
-- ALTER TABLE public.reguser OWNER TO postgres;
-- ddl-end --

-- object: public.altauth | type: TABLE --
-- DROP TABLE IF EXISTS public.altauth CASCADE;
CREATE TABLE public.altauth(
	regusersn integer NOT NULL,
	challenge1 text,
	response1 text,
	challenge2 text,
	response2 text,
	CONSTRAINT altauth_regusersn UNIQUE (regusersn)

);
-- ddl-end --
-- ALTER TABLE public.altauth OWNER TO postgres;
-- ddl-end --

-- object: public.hiddentool | type: TABLE --
-- DROP TABLE IF EXISTS public.hiddentool CASCADE;
CREATE TABLE public.hiddentool(
	toolsn integer NOT NULL,
	CONSTRAINT hiddentool_pk PRIMARY KEY (toolsn)

);
-- ddl-end --
-- ALTER TABLE public.hiddentool OWNER TO postgres;
-- ddl-end --

-- object: public.nogrant | type: TABLE --
-- DROP TABLE IF EXISTS public.nogrant CASCADE;
CREATE TABLE public.nogrant(
	privilegesn integer NOT NULL,
	CONSTRAINT nogrant_pk PRIMARY KEY (privilegesn)

);
-- ddl-end --
-- ALTER TABLE public.nogrant OWNER TO postgres;
-- ddl-end --

-- object: public.user_metapriv | type: TABLE --
-- DROP TABLE IF EXISTS public.user_metapriv CASCADE;
CREATE TABLE public.user_metapriv(
	regusersn integer NOT NULL,
	privilegesn integer NOT NULL,
	CONSTRAINT user_metapriv_pk PRIMARY KEY (regusersn,privilegesn)

);
-- ddl-end --
-- ALTER TABLE public.user_metapriv OWNER TO postgres;
-- ddl-end --

-- object: public.user_priv | type: TABLE --
-- DROP TABLE IF EXISTS public.user_priv CASCADE;
CREATE TABLE public.user_priv(
	regusersn integer NOT NULL,
	privilegesn integer NOT NULL,
	CONSTRAINT user_priv_pk PRIMARY KEY (regusersn,privilegesn)

);
-- ddl-end --
-- ALTER TABLE public.user_priv OWNER TO postgres;
-- ddl-end --

-- object: public.report_priv | type: TABLE --
-- DROP TABLE IF EXISTS public.report_priv CASCADE;
CREATE TABLE public.report_priv(
	reportsn integer NOT NULL,
	privilegesn integer NOT NULL,
	CONSTRAINT report_priv_pk PRIMARY KEY (reportsn,privilegesn)

);
-- ddl-end --
-- ALTER TABLE public.report_priv OWNER TO postgres;
-- ddl-end --

-- object: public.tool_priv | type: TABLE --
-- DROP TABLE IF EXISTS public.tool_priv CASCADE;
CREATE TABLE public.tool_priv(
	toolsn integer NOT NULL,
	privilegesn integer NOT NULL,
	CONSTRAINT tool_priv_pk PRIMARY KEY (toolsn,privilegesn)

);
-- ddl-end --
-- ALTER TABLE public.tool_priv OWNER TO postgres;
-- ddl-end --

-- object: reguser_personsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.reguser DROP CONSTRAINT IF EXISTS reguser_personsn_fk CASCADE;
ALTER TABLE public.reguser ADD CONSTRAINT reguser_personsn_fk FOREIGN KEY (personsn)
REFERENCES public.person (personsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: altauth_regusersn_fk | type: CONSTRAINT --
-- ALTER TABLE public.altauth DROP CONSTRAINT IF EXISTS altauth_regusersn_fk CASCADE;
ALTER TABLE public.altauth ADD CONSTRAINT altauth_regusersn_fk FOREIGN KEY (regusersn)
REFERENCES public.reguser (regusersn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: hiddentool_toolsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.hiddentool DROP CONSTRAINT IF EXISTS hiddentool_toolsn_fk CASCADE;
ALTER TABLE public.hiddentool ADD CONSTRAINT hiddentool_toolsn_fk FOREIGN KEY (toolsn)
REFERENCES public.tool (toolsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: nogrant_privilegesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.nogrant DROP CONSTRAINT IF EXISTS nogrant_privilegesn_fk CASCADE;
ALTER TABLE public.nogrant ADD CONSTRAINT nogrant_privilegesn_fk FOREIGN KEY (privilegesn)
REFERENCES public.privilege (privilegesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: user_metapriv_regusersn_fk | type: CONSTRAINT --
-- ALTER TABLE public.user_metapriv DROP CONSTRAINT IF EXISTS user_metapriv_regusersn_fk CASCADE;
ALTER TABLE public.user_metapriv ADD CONSTRAINT user_metapriv_regusersn_fk FOREIGN KEY (regusersn)
REFERENCES public.reguser (regusersn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: user_metapriv_privilegesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.user_metapriv DROP CONSTRAINT IF EXISTS user_metapriv_privilegesn_fk CASCADE;
ALTER TABLE public.user_metapriv ADD CONSTRAINT user_metapriv_privilegesn_fk FOREIGN KEY (privilegesn)
REFERENCES public.privilege (privilegesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: user_priv_privilegesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.user_priv DROP CONSTRAINT IF EXISTS user_priv_privilegesn_fk CASCADE;
ALTER TABLE public.user_priv ADD CONSTRAINT user_priv_privilegesn_fk FOREIGN KEY (privilegesn)
REFERENCES public.privilege (privilegesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: user_priv_regusersn_fkey | type: CONSTRAINT --
-- ALTER TABLE public.user_priv DROP CONSTRAINT IF EXISTS user_priv_regusersn_fkey CASCADE;
ALTER TABLE public.user_priv ADD CONSTRAINT user_priv_regusersn_fkey FOREIGN KEY (regusersn)
REFERENCES public.reguser (regusersn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: report_priv_privilegesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.report_priv DROP CONSTRAINT IF EXISTS report_priv_privilegesn_fk CASCADE;
ALTER TABLE public.report_priv ADD CONSTRAINT report_priv_privilegesn_fk FOREIGN KEY (privilegesn)
REFERENCES public.privilege (privilegesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: report_priv_reportsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.report_priv DROP CONSTRAINT IF EXISTS report_priv_reportsn_fk CASCADE;
ALTER TABLE public.report_priv ADD CONSTRAINT report_priv_reportsn_fk FOREIGN KEY (reportsn)
REFERENCES public.report (reportsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: tool_priv_privilegesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.tool_priv DROP CONSTRAINT IF EXISTS tool_priv_privilegesn_fk CASCADE;
ALTER TABLE public.tool_priv ADD CONSTRAINT tool_priv_privilegesn_fk FOREIGN KEY (privilegesn)
REFERENCES public.privilege (privilegesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: tool_priv_toolsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.tool_priv DROP CONSTRAINT IF EXISTS tool_priv_toolsn_fk CASCADE;
ALTER TABLE public.tool_priv ADD CONSTRAINT tool_priv_toolsn_fk FOREIGN KEY (toolsn)
REFERENCES public.tool (toolsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --


