#!/bin/sh
######################################################################
# parseformargs.sh
######################################################################
# Copyright 2010 Theodore B. Ruegsegger
# This file is part of the GAPP Kit.

# The GAPP Kit is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# The GAPP Kit is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
######################################################################
PrintHelp()
{
cat <<EOF

parseformargs.sh

Given, in $STDIN, a URL with GET arguments, extracts all the
arguments, one per line, as PHP variables. Output to $STDOUT unless
the -x option is present, in which case it's piped to xless

Usage:
    parseformargs.sh [ -hx ]

Options:
    -h
        Display a help message listing options.

    -x
        Display the results in a window using xless

EOF
return  
}

######################################################################
# Parse command line options
while getopts "hx" Option
do
    case $Option in
      h ) PrintHelp
          exit
          ;;
      x ) Display=True
          ;;
    esac
done

echo -n 'Enter URL: '
read URL
echo

if [ $Display ]
then
    echo $URL | sed -e 's/^[^?][^?]*?/\$/' -e 's/&/\n\$/g' \
	| xless -title "Form Arguments" &
else
    echo $URL | sed -e 's/^[^?][^?]*?/\$/' -e 's/&/\n\$/g'
fi

echo
