#!/bin/sh
######################################################################
# showtablecolumns.sh
######################################################################
# Copyright 2010 Theodore B. Ruegsegger
# This file is part of the GAPP Kit.

# The GAPP Kit is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# The GAPP Kit is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
######################################################################

# For each table in the specified database, outputs a line:
# tablename(column1, column2, ..., columnN)

# Usage:
#     showtablecolumns.sh database

# PostgreSQL displays sequences along with tables; to omit them:
#     showtablecolumns.sh database | grep -v '_seq('

######################################################################
if [ $# -lt 1 ]
then
    echo Usage: showtablecolumns.sh database
    exit
fi
Database=$1
DbUser=$(echo $Database | sed -e 's/_.*$//')

Tables=$(psql -qtd $Database -U $DbUser -c "\d" | awk '{print $3}')
for Table in $Tables
do
    psql -qd $Database -U $DbUser \
	-c "SELECT * FROM $Table WHERE FALSE" \
	| sed -ne 1p \
	| sed -e 's/ |/,/g' \
	| sed -e "s/^ /$Table(/" \
	| sed -e 's/ $/)/'
done
