-- Database generated with pgModeler (PostgreSQL Database Modeler).
-- pgModeler version: 0.9.4
-- PostgreSQL version: 13.0
-- Project Site: pgmodeler.io
-- Model Author: ---

-- Database creation must be performed outside a multi lined SQL file. 
-- These commands were put in this file only as a convenience.
-- 
-- object: trove | type: DATABASE --
-- DROP DATABASE IF EXISTS trove;
CREATE DATABASE trove;
-- ddl-end --


-- object: public.photoset | type: TABLE --
-- DROP TABLE IF EXISTS public.photoset CASCADE;
CREATE TABLE public.photoset (
	photosetsn serial NOT NULL,
	foldername text NOT NULL,
	notes text,
	nickname text,
	CONSTRAINT photoset_pk PRIMARY KEY (photosetsn)
);
-- ddl-end --
ALTER TABLE public.photoset OWNER TO postgres;
-- ddl-end --

-- object: public.location | type: TABLE --
-- DROP TABLE IF EXISTS public.location CASCADE;
CREATE TABLE public.location (
	locationsn serial NOT NULL,
	name text NOT NULL,
	last_used timestamp,
	notes text,
	CONSTRAINT location_pk PRIMARY KEY (locationsn)
);
-- ddl-end --
ALTER TABLE public.location OWNER TO postgres;
-- ddl-end --

-- object: public.archivedlocation | type: TABLE --
-- DROP TABLE IF EXISTS public.archivedlocation CASCADE;
CREATE TABLE public.archivedlocation (
	locationsn integer NOT NULL,
	CONSTRAINT archivedlocation_pk PRIMARY KEY (locationsn)
);
-- ddl-end --
ALTER TABLE public.archivedlocation OWNER TO postgres;
-- ddl-end --

-- object: public.photo | type: TABLE --
-- DROP TABLE IF EXISTS public.photo CASCADE;
CREATE TABLE public.photo (
	photosn serial NOT NULL,
	photosetsn integer NOT NULL,
	filename text NOT NULL,
	locationsn integer,
	description text,
	width integer,
	height integer,
	thumbw integer,
	thumbh integer,
	"time" timestamptz,
	latitude double precision,
	longitude double precision,
	altitude real,
	CONSTRAINT photo_pk PRIMARY KEY (photosn)
);
-- ddl-end --
ALTER TABLE public.photo OWNER TO postgres;
-- ddl-end --

-- object: public.deletedset | type: TABLE --
-- DROP TABLE IF EXISTS public.deletedset CASCADE;
CREATE TABLE public.deletedset (
	foldername text NOT NULL,
	CONSTRAINT deletedset_pk PRIMARY KEY (foldername)
);
-- ddl-end --
ALTER TABLE public.deletedset OWNER TO postgres;
-- ddl-end --

-- object: public.video | type: TABLE --
-- DROP TABLE IF EXISTS public.video CASCADE;
CREATE TABLE public.video (
	videosn serial NOT NULL,
	vidfilename text NOT NULL,
	stillsn integer NOT NULL,
	width integer,
	height integer,
	CONSTRAINT video_pk PRIMARY KEY (videosn)
);
-- ddl-end --
ALTER TABLE public.video OWNER TO postgres;
-- ddl-end --

-- object: public.derived_photo | type: TABLE --
-- DROP TABLE IF EXISTS public.derived_photo CASCADE;
CREATE TABLE public.derived_photo (
	childphotosn integer NOT NULL,
	parentphotosn integer NOT NULL,
	CONSTRAINT derived_photo_pk PRIMARY KEY (childphotosn,parentphotosn)
);
-- ddl-end --
ALTER TABLE public.derived_photo OWNER TO postgres;
-- ddl-end --

-- object: public.tag | type: TABLE --
-- DROP TABLE IF EXISTS public.tag CASCADE;
CREATE TABLE public.tag (
	tagsn serial NOT NULL,
	name text NOT NULL,
	last_used timestamp,
	notes text,
	CONSTRAINT tag_pk PRIMARY KEY (tagsn),
	CONSTRAINT tag_name UNIQUE (name)
);
-- ddl-end --
ALTER TABLE public.tag OWNER TO postgres;
-- ddl-end --

-- object: public.archivedtag | type: TABLE --
-- DROP TABLE IF EXISTS public.archivedtag CASCADE;
CREATE TABLE public.archivedtag (
	tagsn integer NOT NULL,
	CONSTRAINT archivedtag_pk PRIMARY KEY (tagsn)
);
-- ddl-end --
ALTER TABLE public.archivedtag OWNER TO postgres;
-- ddl-end --

-- object: public.tag_photo | type: TABLE --
-- DROP TABLE IF EXISTS public.tag_photo CASCADE;
CREATE TABLE public.tag_photo (
	tagsn integer NOT NULL,
	photosn integer NOT NULL,
	CONSTRAINT tag_photo_pk PRIMARY KEY (tagsn,photosn)
);
-- ddl-end --
ALTER TABLE public.tag_photo OWNER TO postgres;
-- ddl-end --

-- object: public.album | type: TABLE --
-- DROP TABLE IF EXISTS public.album CASCADE;
CREATE TABLE public.album (
	albumsn serial NOT NULL,
	name text NOT NULL,
	title text,
	bgcolor text DEFAULT '#d0e0ff',
	textcolor text DEFAULT '#000000',
	vidbgcolor text DEFAULT '#ffff90',
	author text,
	url text,
	notes text,
	pubdate date,
	CONSTRAINT album_pk PRIMARY KEY (albumsn),
	CONSTRAINT album_name UNIQUE (name)
);
-- ddl-end --
ALTER TABLE public.album OWNER TO postgres;
-- ddl-end --

-- object: album_pubdate | type: INDEX --
-- DROP INDEX IF EXISTS public.album_pubdate CASCADE;
CREATE INDEX album_pubdate ON public.album
USING btree
(
	pubdate
);
-- ddl-end --

-- object: album_title | type: INDEX --
-- DROP INDEX IF EXISTS public.album_title CASCADE;
CREATE INDEX album_title ON public.album
USING btree
(
	title
);
-- ddl-end --

-- object: public.archivedalbum | type: TABLE --
-- DROP TABLE IF EXISTS public.archivedalbum CASCADE;
CREATE TABLE public.archivedalbum (
	albumsn integer NOT NULL,
	CONSTRAINT archivedalbum_pk PRIMARY KEY (albumsn)
);
-- ddl-end --
ALTER TABLE public.archivedalbum OWNER TO postgres;
-- ddl-end --

-- object: public.albumpage | type: TABLE --
-- DROP TABLE IF EXISTS public.albumpage CASCADE;
CREATE TABLE public.albumpage (
	albumpagesn serial NOT NULL,
	albumsn integer NOT NULL,
	page integer NOT NULL,
	heading text,
	titlepicord integer DEFAULT 0,
	titlepiccaption text,
	pagetext text,
	CONSTRAINT albumpage_pk PRIMARY KEY (albumpagesn),
	CONSTRAINT albumpage_albumsn_page UNIQUE (albumsn,page)
);
-- ddl-end --
ALTER TABLE public.albumpage OWNER TO postgres;
-- ddl-end --

-- object: public.albumphoto | type: TABLE --
-- DROP TABLE IF EXISTS public.albumphoto CASCADE;
CREATE TABLE public.albumphoto (
	albumphotosn serial NOT NULL,
	albumpagesn integer NOT NULL,
	photosn integer NOT NULL,
	ordinal integer NOT NULL,
	caption text,
	CONSTRAINT albumphoto_pk PRIMARY KEY (albumphotosn),
	CONSTRAINT albumphoto_albumpagesn_ordinal UNIQUE (albumpagesn,ordinal)
);
-- ddl-end --
ALTER TABLE public.albumphoto OWNER TO postgres;
-- ddl-end --

-- object: locationsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.archivedlocation DROP CONSTRAINT IF EXISTS locationsn_fk CASCADE;
ALTER TABLE public.archivedlocation ADD CONSTRAINT locationsn_fk FOREIGN KEY (locationsn)
REFERENCES public.location (locationsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: photosetsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.photo DROP CONSTRAINT IF EXISTS photosetsn_fk CASCADE;
ALTER TABLE public.photo ADD CONSTRAINT photosetsn_fk FOREIGN KEY (photosetsn)
REFERENCES public.photoset (photosetsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: locationsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.photo DROP CONSTRAINT IF EXISTS locationsn_fk CASCADE;
ALTER TABLE public.photo ADD CONSTRAINT locationsn_fk FOREIGN KEY (locationsn)
REFERENCES public.location (locationsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: stillsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.video DROP CONSTRAINT IF EXISTS stillsn_fk CASCADE;
ALTER TABLE public.video ADD CONSTRAINT stillsn_fk FOREIGN KEY (stillsn)
REFERENCES public.photo (photosn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: childphotosn_fk | type: CONSTRAINT --
-- ALTER TABLE public.derived_photo DROP CONSTRAINT IF EXISTS childphotosn_fk CASCADE;
ALTER TABLE public.derived_photo ADD CONSTRAINT childphotosn_fk FOREIGN KEY (childphotosn)
REFERENCES public.photo (photosn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: parentphotosn_fk | type: CONSTRAINT --
-- ALTER TABLE public.derived_photo DROP CONSTRAINT IF EXISTS parentphotosn_fk CASCADE;
ALTER TABLE public.derived_photo ADD CONSTRAINT parentphotosn_fk FOREIGN KEY (parentphotosn)
REFERENCES public.photo (photosn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: archivedtag_tagsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.archivedtag DROP CONSTRAINT IF EXISTS archivedtag_tagsn_fk CASCADE;
ALTER TABLE public.archivedtag ADD CONSTRAINT archivedtag_tagsn_fk FOREIGN KEY (tagsn)
REFERENCES public.tag (tagsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: tag_photo_photosn_fk | type: CONSTRAINT --
-- ALTER TABLE public.tag_photo DROP CONSTRAINT IF EXISTS tag_photo_photosn_fk CASCADE;
ALTER TABLE public.tag_photo ADD CONSTRAINT tag_photo_photosn_fk FOREIGN KEY (photosn)
REFERENCES public.photo (photosn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: tag_photo_tagsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.tag_photo DROP CONSTRAINT IF EXISTS tag_photo_tagsn_fk CASCADE;
ALTER TABLE public.tag_photo ADD CONSTRAINT tag_photo_tagsn_fk FOREIGN KEY (tagsn)
REFERENCES public.tag (tagsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: archivedalbum_albumsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.archivedalbum DROP CONSTRAINT IF EXISTS archivedalbum_albumsn_fk CASCADE;
ALTER TABLE public.archivedalbum ADD CONSTRAINT archivedalbum_albumsn_fk FOREIGN KEY (albumsn)
REFERENCES public.album (albumsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: albumpage_albumsn_fk | type: CONSTRAINT --
-- ALTER TABLE public.albumpage DROP CONSTRAINT IF EXISTS albumpage_albumsn_fk CASCADE;
ALTER TABLE public.albumpage ADD CONSTRAINT albumpage_albumsn_fk FOREIGN KEY (albumsn)
REFERENCES public.album (albumsn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: albumphoto_albumpagesn_fk | type: CONSTRAINT --
-- ALTER TABLE public.albumphoto DROP CONSTRAINT IF EXISTS albumphoto_albumpagesn_fk CASCADE;
ALTER TABLE public.albumphoto ADD CONSTRAINT albumphoto_albumpagesn_fk FOREIGN KEY (albumpagesn)
REFERENCES public.albumpage (albumpagesn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --

-- object: albumphoto_photosn_fk | type: CONSTRAINT --
-- ALTER TABLE public.albumphoto DROP CONSTRAINT IF EXISTS albumphoto_photosn_fk CASCADE;
ALTER TABLE public.albumphoto ADD CONSTRAINT albumphoto_photosn_fk FOREIGN KEY (photosn)
REFERENCES public.photo (photosn) MATCH FULL
ON DELETE NO ACTION ON UPDATE NO ACTION;
-- ddl-end --


