/*********************************************************************
updateschema.sql

Adds new database tables and values for the PhotoTrove web application
service.
______________________________________________________________________
Copyright 2022 Theodore B. Ruegsegger
This file is part of the PhotoTrove web application.

PhotoTrove is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PhotoTrove is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

Usage:
	psql -d database -U dbuser -f updateschema.sql

*********************************************************************/
/*********************************************************************
Changes for past versions
*********************************************************************/

/*
-- Add required tags
INSERT INTO tag(name, notes)
SELECT 'panorama-to-do',
'one of a series of images waiting to be stitched into a panorama'
WHERE NOT EXISTS
(SELECT * FROM tag WHERE name = 'panorama-to-do');

INSERT INTO tag(name, notes)
SELECT 'panorama',
'panoramic view stitched together from a series of images'
WHERE NOT EXISTS
(SELECT * FROM tag WHERE name = 'panorama');

INSERT INTO tag(name, notes)
SELECT 'component',
'One of a series of images that are parts of a compound structure, but otherwise not &quot;interesting&quot; in their own right, for example, segments of a panorama'
WHERE NOT EXISTS
(SELECT * FROM tag WHERE name = 'component');


-- Add tool to capture geo-data (dbversion: db20190124)
UPDATE tool SET dispord = dispord + 1
WHERE dispord >
(SELECT dispord FROM tool WHERE name = 'dumpdb.php')
AND NOT EXISTS
(SELECT * FROM tool WHERE name = 'capturegps.php');

INSERT INTO tool(name, dispord, description)
SELECT 'capturegps.php', 13, 'Capture geo-data'
WHERE NOT EXISTS
(SELECT * FROM tool WHERE name = 'capturegps.php');

INSERT INTO tool_priv(toolsn, privilegesn)
SELECT toolsn, privilegesn FROM tool, privilege
WHERE name = 'capturegps.php' AND privname = 'edit'
AND NOT EXISTS
(SELECT * FROM tool_priv tp, tool t
WHERE name = 'capturegps.php' AND tp.toolsn = t.toolsn);
*/

/*********************************************************************
Changes for latest version

Be sure to target specific older versions by adding a clause like:
WHERE NOT EXISTS (SELECT 1 FROM dbversion)
or
WHERE EXISTS (SELECT 1 FROM dbversion WHERE dbversion = 'db20150127')
*********************************************************************/


-- Set default colors for album background and text (dbversion:
-- db20220624)
ALTER TABLE album
 ALTER COLUMN bgcolor SET DEFAULT '#d0e0ff',
 ALTER COLUMN textcolor SET DEFAULT '#000000';
