<?php
/*********************************************************************
aboutphototrove.php

Describe PhotoTrove, its origins  and license requirements.
______________________________________________________________________
Copyright 2023 Theodore B. Ruegsegger
This file is part of the PhotoTrove web application.

PhotoTrove is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PhotoTrove is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

*********************************************************************/
require_once ("lib_common.php");
require_once ("lib_layout.php");

$T = "<h3>What Is PhotoTrove?</h3>\n

<p>Now that we all have digital cameras and smart phones that never
run out of film, more and more of us are finding it difficult to keep
track of all our photos and videos. It's easy to accumulate tens of
thousands of photos in a short time, and sticking them into labeled
folders on our computers works about as well as when we kept our
prints and negatives in shoeboxes. Why not use all this computer power
to do the housekeeping for us?</p>\n

<p>PhotoTrove uses an industrial-quality database management system to
keep track of every photo and video in a large collection, with
detailed descriptions, timestamps and locations so you can find them
easily, edit them, group them, compare them, arrange them and
conveniently publish them. It includes a comprehensive search tool as
well as easy handoff to your favorite photo-editing tools.</p>\n

<p>PhotoTrove runs as a web application on your local network (perhaps
even as a virtual machine running on your laptop), so multiple users
can work independently and simultaneously. Anyone whose browser can
see PhotoTrove can view photo sets and albums, carry out searches and
download individual photos, but only authorized users can change
anything. Since all the data is in one place, it's easy to set up
automatic backups so you can be confident your valued photos are
safe.</p>\n

<h3>Features</h3>\n

<p>With PhotoTrove and your favorite web browser, you can:</p>\n
<ul>\n
<li>Keep track of <em>all</em> your photos and videos, with
descriptions, timestamps and locations.</li>\n
<li>Edit the images and videos using your favorite tools, with special
support for stitching panoramas.</li>\n
<li>Make up descriptive tags and attach them to any photos you wish,
to enable complex searches and group actions.</li>\n
<li>Locate photos in your collection, searching by pretty much
anything: date range, location, text in descriptions and captions,
tags, etc. and then carry out group operations on all matching
photos.</li>\n
<li>Assemble albums by selecting images from multiple photo sets and
adding layout and captions.</li>\n
<li>Publish albums as collections of static HTML documents that you
can burn to a CD, copy to a thumbdrive, or upload to a website. Yes,
they'll still play videos in the browser, either way.</li>\n
</ul>\n

<h3>License</h3>\n

<p>Copyright &copy; 2023 <a href=\"http://toyrus.ngrok.io/~ted/\"
target=\"_blank\">Theodore B. Ruegsegger</a>.</p>

<p>This <a href=\"http://toyrus.ngrok.io/~ted/phototrove/\"
target=\"_blank\">collection of program code and documentation</a> is
free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your
option) any later version.</p>\n

<p>This collection is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the <a
href=\"http://www.gnu.org/licenses/gpl.html\" target=\"_blank\">GNU
General Public License</a> for more details.</p>\n ";

define("Introduction", $T);

$T = BoxStyle."; width: 62%; text-align: left; margin-bottom: 2mm";
define("IntroStyle", $T);

$T = "<style type=\"text/css\">
p {line-height: 1.2}
ul, ol, li > p {line-height: 1.2}
</style>";
define ("Styles", $T);

//********************************************************************
$S = StartOfPage("About PhotoTrove", Styles);

$S .= "<div style=\"".IntroStyle."\">".Introduction;
$S .= "</div>\n";
$S .= "</div></body></html>\n";
echo $S;


?>
