<?php
/*********************************************************************
dumpdb.php
Export Database Module for PhotoTrove
______________________________________________________________________
Copyright 2019 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________
*********************************************************************/
require_once ("lib_common.php");
require_once ("lib_layout.php");

$T = "The most reliable way to back up the database is to ";
$T .= "&quot;dump&quot; its contents as a specially-formatted text";
$T .= " file that the database management system can read.";
$T .= " Activating this page should just now have done that.";
define ("Explanation", $T);
$T = "Be sure to keep copies of these dumped files somewhere safe.";
define ("Advice", $T);

//********************************************************************
// $Database and $DbUser are set in lib_common.php
$Cmd = "dumpdbandpurgeold.sh -zn 8 $Database $DbUser";
exec("$Cmd", $Result);

$S = StartOfPage("Export Database");
$S .= "<div style=\"".BoxStyle."; width: 50%; text-align: left\">";
$S .= HtmlPara(Explanation);
$S .= HtmlPara(Advice);
$S .= "</div>\n";
foreach ($Result as $Line)
{
    $S .= StrWarning($Line, NoticeColor);
}

$S .= "</div></body></html>\n";
echo $S;

?>
