<?php
/*********************************************************************
altauth.php

Authenticate user with challenge and response
______________________________________________________________________
Copyright 2015 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________
*********************************************************************/
require ("lib_usermgt.php");
require ('lib_crypto.php');

function Challenge2FromResponse1($UserId, $Response1)
{
    $Q = "SELECT response1 FROM altauth a, reguser r";
    $Q .= " WHERE userid = $1 AND a.regusersn = r.regusersn";
    $SavedCypher = pg_fetch_result(Query($Q, $UserId), 0);
    $Cypher1 = crypt(strtolower($Response1), $SavedCypher);
    $Q = "SELECT challenge2 FROM altauth a, reguser r";
    $Q .= " WHERE userid = $1 AND a.regusersn = r.regusersn";
    $Q .= " AND response1 = '$Cypher1'";
    $Res = Query($Q, $UserId);
    return (pg_num_rows($Res) > 0) ? pg_fetch_result($Res, 0) : False;
}

function FormChallenge1($UserId)
{
    $Q = "SELECT challenge1 FROM altauth a, reguser r";
    $Q .= " WHERE userid = $1 AND a.regusersn = r.regusersn";
    $Res = Query($Q, $UserId);
    if (pg_num_rows($Res) > 0)
    {
	$Challenge1 = pg_fetch_result($Res, 0);
	$S = "<p style=\"width: 70%; text-align: left\">";
	$S .= "$Challenge1</p>\n";
	$S .= "<form action=\"".ThisScript()."\" method=\"post\">\n";
	$S .= HtmlHidden("UserId", $UserId);
	$S .= "<input type=\"password\" name=\"Response1\"";
	$S .= " size=\"60\">\n";
	$S .= HtmlPara(HtmlSubmitButton("SubmitResponse1", "Submit"),
		       "center");
	// Tag so main can route properly
	$S .= HtmlHidden("TryAltAuth", "Use Alternate");
	$S .= StrFormEnd();
    } else
    {
	$T = "Sorry, account &quot;$UserId&quot; hasn't set up";
	$T .= " alternate authentication. ".PasswordResetInstructions;
	$S = StrWarningBox($T, "50%");
	$S .= FormUserId();
    }
    return $S;
}

function FormChallenge2($UserId, $Response1)
{
    $Response1 = SansSpecialChars($Response1);
    $Challenge2 = Challenge2FromResponse1($UserId, $Response1);
    if ($Challenge2)
    {
	$S = "<p style=\"width: 70%; text-align: left\">";
	$S .= "$Challenge2</p>\n";
	$S .= "<form action=\"".ThisScript()."\" method=\"post\">\n";
	$S .= HtmlHidden("UserId", $UserId);
	$S .= HtmlHidden("Response1", $Response1);
	$S .= "<input type=\"password\" name=\"Response2\"";
	$S .= " size=\"60\">\n";
	$S .= HtmlPara(HtmlSubmitButton("SubmitResponse2", "Submit"),
		       "center");
	// Tag so main can route properly
	$S .= HtmlHidden("TryAltAuth", "Use Alternate");
	$S .= StrFormEnd();
    } else
    {
	$T = "Sorry, your response doesn't match the one set up for";
	$T .= " account &quot;$UserId&quot;. You may try again;";
	$T .= " otherwise, ";
	$T .= strtolower(substr(PasswordResetInstructions, 0, 1));
	$T .= substr(PasswordResetInstructions, 1);
	$S = StrWarningBox($T, "50%");
	$S .= FormChallenge1($UserId);
    }
    return $S;
}

function FormResetPassword($UserId, $Response1, $Response2)
{
    $S = HtmlPara(LegalPasswordMsg);
    $S .= "<form action=\"".ThisScript()."\" method=\"post\">\n";
    $S .= HtmlHidden("UserId", $UserId);
    $S .= HtmlHidden("Response1", $Response1);
    $S .= HtmlHidden("Response2", $Response2);
    $S .= StrTableBegin("0");
    $S .= StrUserAccountFormLine("Password", "New Password",
				 "NewPassword", 16, "", True);
    $S .= StrUserAccountFormLine("New Password, again",
				 "Repeat New Password",
				 "VerPassword", 16, "", True);
    $S .= StrTableEnd();
    $S .= HtmlPara(HtmlSubmitButton("SetNewPassword", "Set"),
		   "center");
    // Tag so main can route properly
    $S .= HtmlHidden("TryAltAuth", "Use Alternate");
    $S .= StrFormEnd();
    return $S;
}

function FormUserId()
{
    $S = "<p style=\"width: 70%; text-align: left\">";
    $S .= AltAuthPrompt."</p>\n";
    $S .= "<form action=\"".ThisScript()."\" method=\"post\">\n";
    $S .= StrTableBegin("0");
    $S .= StrUserAccountFormLine("The account ID you use to log in",
				 "User ID", "UserId", 10);
    $S .= StrTableEnd();
    $S .= HtmlPara(HtmlSubmitButton("SubmitId", "Submit"), "center");
    // Tag so main can route properly
    $S .= HtmlHidden("TryAltAuth", "Use Alternate");
    $S .= StrFormEnd();
    return $S;
}

function IsUserAuthenticated($UserId, $Response1, $Response2)
{
    // Validates both responses in case of argument hacking
    $Q = "SELECT response1, response2 FROM altauth a, reguser r";
    $Q .= " WHERE userid = $1 AND a.regusersn = r.regusersn";
    list($SavedCypher1, $SavedCypher2)
	= pg_fetch_array(Query($Q, $UserId), 0);
    $Cypher1 = crypt(strtolower($Response1), $SavedCypher1);
    $Cypher2 = crypt(strtolower($Response2), $SavedCypher2);
    return($Cypher1 == $SavedCypher1 and $Cypher2 == $SavedCypher2);
}

function PageResetPassword($UserId, $Response1, $Response2)
{
    $Response2 = SansSpecialChars($Response2);
    if (IsUserAuthenticated($UserId, $Response1, $Response2))
    {
	// retrieve the user record corresponding to userid; since
	// $_SESSION["UserRec"] is registered, this effectively logs
	// the user in
	$Q = "SELECT r.userid, r.passwd_hash, r.passwd_changed,";
	$Q .= " r.personsn, p.*";
	$Q .= " FROM reguser r, person p";
	$Q .= " WHERE r.userid = $1 AND p.personsn = r.personsn";
	$_SESSION["UserRec"] = pg_fetch_array(Query($Q, $UserId), 0);
	$S = "<p style=\"width: 70%; text-align: left\">";
	$S .= $_SESSION["UserRec"]["firstname"]." ";
	$S .= $_SESSION["UserRec"]["lastname"];
	$S .= ", you're logged in and may now set a new password.";
	$S .= "</p>\n";
	$S .= FormResetPassword($UserId, $Response1, $Response2);
    } else
    {
	$T = "Sorry, your response doesn't match the one set up for";
	$T .= " account &quot;$UserId&quot;. You may try again;";
	$T .= " otherwise, ";
	$T .= strtolower(substr(PasswordResetInstructions, 0, 1));
	$T .= substr(PasswordResetInstructions, 1);
	$S = StrWarningBox($T, "50%");
	$S .= FormChallenge2($UserId, $Response1);
    }
    return $S;
}

function PageValidatePassword($Path, $UserId, $Response1, $Response2,
			      $NewPassword, $VerPassword)
{
    if (IsUserAuthenticated($UserId, $Response1, $Response2))
    {
	$E = (PasswordLegal($NewPassword)) ? ""
	    : LegalPasswordMsg."<br>\n";
	$E .= ($NewPassword == $VerPassword) ? ""
	    : "Repeated password doesn't match.<br>\n";
	if ($E == "")
	{
	    $NewCypherText = Encrypted($NewPassword);
	    $Q = "UPDATE reguser SET";
	    $Q .= " passwd_hash = '$NewCypherText',";
	    $Q .= " passwd_changed = CURRENT_DATE";
	    $Q .= " WHERE userid = $1";
	    Query ($Q, $UserId);
	    // Refresh user record
	    $Q = "SELECT r.userid, r.passwd_hash, r.passwd_changed,";
	    $Q .= " r.personsn, p.*";
	    $Q .= " FROM reguser r, person p";
	    $Q .= " WHERE r.userid = $1";
	    $Q .= " AND p.personsn = r.personsn";
	    $_SESSION["UserRec"]
		= pg_fetch_array(Query($Q, $UserId), 0);
	    $PasswordChanged = True;
	    // Blank output to revert to LoginScript:
	    $S = "";
	} else
	{
	    $S = StrWarningBox($E."Password unchanged.");
	    $S .= FormResetPassword($UserId, $Response1, $Response2);
	}
    } else
	$S = StrWarningBox("Authentication lost.");
    return $S;
}

//********************************************************************
// Fetch input variables
$PostVarList = array(
    "NewPassword",
    "Response1",
    "Response2",
    "UserId",
    "VerPassword"
   );
foreach ($PostVarList as $Var)
    if (isset($_POST[$Var])) $$Var = trim($_POST[$Var]);

$T = "Alternate Authentication";
$Z = HeadAndTitle("$SystemTitle $T");
$Z .= PageTitleWithButton($T, BtnMainMenu());
$Z .= "<div align=\"center\">\n";

if (isset($_POST["SubmitId"]))
    $Z .= FormChallenge1($UserId);
elseif (isset($_POST["SubmitResponse1"]))
    $Z .= FormChallenge2($UserId, $Response1);
elseif (isset($_POST["SubmitResponse2"]))
    $Z .= PageResetPassword($UserId, $Response1, $Response2);
elseif (isset($_POST["SetNewPassword"]))
{
    $T = PageValidatePassword($Path, $UserId, $Response1, $Response2,
			      $NewPassword, $VerPassword);
    if ($T == "")
    {
	$PasswordChanged = True;
	$Z = "";
    } else $Z .= $T;
} else
    $Z .= FormUserId();

if ($Z > "") $S = $Z;

?>
