<?php
/*********************************************************************
gk_changepw.php

Password Change Screen for PHP Scripts
______________________________________________________________________
Copyright 2010 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________
*********************************************************************/
define("MsgBadVerify",
       "Repeated password doesn't match.<br>Password unchanged.");
define("MsgChangeFailed", "<br>\nPassword unchanged.");
define("MsgCurrentWrong", "Current password incorrectly entered.");
define("MsgDbUpdateFailed", "Database update failed");
$T = ($PasswordDying > 1) ? "in $PasswordDying days" : "tomorrow";
$T = "Password expires $T. Consider changing it now.";
define("MsgPasswordDying", $T);
define("MsgPasswordExpired",
       "Your password has expired. You must change it to continue.");
define("MsgUnchanged", "You didn't change it!");
function StrPasswordChangeBox($Color=LoginBoxColor)
{
    $S = StrBoxBegin("8", "left", $Color);
    $S .= StrTableBegin("0");
    $S .= StrRowBegin();
    $S .= StrCell("&nbsp;", "5");
    $S .= StrRowEnd();
    $S .= StrRowBegin();
    $S .= StrCell("&nbsp;", "", "3");
    $S .= "<td align=\"right\">".Strong("Current Password:");
    $S .= "</td>\n";
    $S .= StrCell("&nbsp;", "", "3");
    $T = "<input type=\"password\" name=\"Password\" size=\"16\">";
    $S .= StrCell($T);
    $S .= StrCell("&nbsp;", "", "3");
    $S .= StrRowEnd();
    $S .= StrRowBegin();
    $S .= "<td align=\"right\">".Strong("New Password:")."</td>\n";
    $T = "<input type=\"password\" name=\"NewPassword\" size=\"16\">";
    $S .= StrCell($T);
    $S .= StrRowEnd();
    $S .= StrRowBegin();
    $S .= "<td align=\"right\">".Strong("Retype New Password:");
    $S .= "</td>\n";
    $T = "<input type=\"password\" name=\"VerPassword\" size=\"16\">";
    $S .= StrCell($T);
    $S .= StrRowEnd();
    $S .= StrRowBegin();
    $S .= StrCell("&nbsp;", "5");
    $S .= StrRowEnd();
    $S .= StrTableEnd();
    $S .= StrBoxEnd();
    $S .= HtmlPara(HtmlSubmitButton("ChangePassword", "Change"));
    return $S;
}

//********************************************************************
$S = HeadAndTitle("$SystemTitle Change Password");
if (isset($ForceNewPasswd)) $S .= StrWarning(MsgPasswordExpired);

if (isset($BadPasswd))
    $S .= StrWarning(MsgCurrentWrong.MsgChangeFailed);
elseif (isset($Unchanged)) $S .= StrWarning(MsgUnchanged);
elseif (isset($BadVerify)) $S .= StrWarning(MsgBadVerify);
elseif (isset($Illegal))
    $S .= StrWarning(LegalPasswordMsg.MsgChangeFailed);
elseif (isset($PasswordChanged) and ! $PasswordChanged)
    $S .= StrWarning(MsgDbUpdateFailed.MsgChangeFailed);
elseif (isset($PasswordDying) and is_numeric($PasswordDying))
    $S .= StrWarning(MsgPasswordDying);

if (isset($ForceNewPasswd))
    $S .= PageTitleWithButton("Change Password", BtnLogOut());
else
    $S .= PageTitleWithButton("Change Password", BtnMainMenu());

$S .= "<div align=\"center\">\n";
$S .= HtmlPara(LegalPasswordMsg);
$S .= "<form action=\"".LoginScript."\" method=\"post\">\n";
if (isset($ForceNewPasswd))
    $S .= HtmlHidden("ForceNewPasswd", $ForceNewPasswd);
$S .= StrPasswordChangeBox();
$S .= StrFormEnd();

$S .= "</div></body></html>\n";
echo $S;

?>
