<?php
/*********************************************************************
gk_jscalendar.php

Definitions needed to use Mihai Bazon's DHTML Calendar Widget, which
provides a pop-up javascript calendar for entering dates in forms.

http://www.dynarch.com/projects/calendar/
______________________________________________________________________
Copyright 2010 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

To install in an application:

1. Download the latest package (a zip file at this writing)

2. Make a subdirectory "jscalendar" under $ServiceRoot and unzip the
   downloaded package into it. Note that the package will probably
   create its own subdirectory "jscalendar-XXX" where "XXX" is the
   version number. Move the contents of jscalendar-XXX directly into
   jscalendar.

3. The generated HTML for any page needing to use the calendar must
   include the calendar definitions (defined herein as the constant
   CalendarDefinitions) in the <head>...</head> part of the
   document. The simplest way is to give CalendarDefinitions as the
   value for the argument $ExtraTags in functions like
   HeadAndTitleSimple and HeadAndTitle.

4. To make a text input box with a calendar button, use the function
   DateInput inside a form.

*********************************************************************/
require("local/loc_jscalendar.php");

$T = "<script type=\"text/javascript\"";
$T .= " src=\"jscalendar/calendar.js\"></script>\n";
$T .= "<script type=\"text/javascript\"";
$T .= " src=\"jscalendar/lang/calendar-en.js\"></script>\n";
$T .= "<script type=\"text/javascript\"";
$T .= " src=\"jscalendar/calendar-setup.js\"></script>";
define("CalendarDefinitions", CalendarStyle.$T);

function DateInput($Name, $Size, $Value="", $MaxLength="",
		   $AutoSubmit=False, $DateFormat=CalFormat)
{
    $S = "<input type=\"text\" id=\"$Name\" name=\"$Name\"";
    $S .= " size=\"$Size\"";
    if ($MaxLength != "") $S .= " maxlength=\"$MaxLength\"";
    if ($Value != "") $S .= " value=\"".htmlentities($Value)."\"";
    if ($AutoSubmit) $S .= " onchange=\"this.form.submit()\"";
    $S .= ">\n";
    $S .= "<button id=\"${Name}Trigger\">";
    $S .= "<img src=\"jscalendar/img.gif\"></button>\n";
    $S .= PopUpCalendar($Name, "${Name}Trigger", $DateFormat);
    return $S;
}

function PopUpCalendar($InputFieldId, $ButtonId,
			$DateFormat=CalFormat)
{
    $S = "<script type=\"text/javascript\">\n";
    $S .= "Calendar.setup(\n";
    $S .= "{\n";
    $S .= "    inputField  : \"$InputFieldId\",\n";
    $S .= "    ifFormat    : \"$DateFormat\",\n";
    $S .= "    button      : \"$ButtonId\",\n";
    $S .= "    weekNumbers : false\n";
    $S .= "}\n";
    $S .= ");\n";
    $S .= "</script>\n";
    return $S;
}

//********************************************************************

?>
