<?php
/*********************************************************************
gk_phpretro.php

Interim functions to provide capabilities to earlier versions of
PHP. They may be removed once the new PHP version is installed.
______________________________________________________________________
Copyright 2010 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

*********************************************************************/
if (!function_exists("file_get_contents"))
{
    // As of PHP 4.3.0. This function is adapted from code posted by
    // webmaster@ragnarokonline.de at
    // http://us2.php.net/manual/en/function.file-get-contents.php
    function file_get_contents($FileName, $UseIncludePath=0)
    {
	$S = "";
	$File = @fopen($FileName, "rb", $UseIncludePath);
	if ($File)
	{
	    while (!feof($File)) $S .= fread($File, 1024);
	    fclose($File);
	}
	return $S;
    }
}

if (! function_exists("html_entity_decode"))
{
    // As of PHP 4.3.0
    // http://www.php.net/manual/en/function.html-entity-decode.php
    function html_entity_decode($String)
    {
	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);
	return strtr($String, $trans_tbl);
    }
}

if (! function_exists("mime_content_type"))
{
    // As of PHP 4.3.0
    // http://us4.php.net/manual/en/function.mime-content-type.php
    function mime_content_type($FilePath)
    {
	return exec("file -bi ".escapeshellcmd($FilePath));
    }
}

if (! function_exists("pg_affected_rows"))
{
    // As of PHP 4.2.0
    function pg_affected_rows($Result)
    {
	return pg_cmdtuples($Result);
    }
}

if (! function_exists("pg_fetch_assoc"))
{
    // As of PHP 4.3.0
    function pg_fetch_assoc($Result, $Row)
    {
	return pg_fetch_array($Result, $Row, PGSQL_ASSOC);
    }
}

if (! function_exists("pg_fetch_result"))
{
    // As of PHP 4.2.0
    function pg_fetch_result($Result, $Row, $Field)
    {
	return pg_result($Result, $Row, $Field);
    }
}

if (! function_exists("pg_last_oid"))
{
    // Note: OIDs are deprecated and no longer available by default;
    // use pg_result_status to check insertion success.

    // As of PHP 4.2.0
    function pg_last_oid($Result)
    {
	return pg_getlastoid($Result);
    }
}

if (! function_exists("pg_num_rows"))
{
    // As of PHP 4.2.0
    function pg_num_rows($Result)
    {
	return pg_numrows($Result);
    }
}

if (! function_exists("pg_query"))
{
    // As of PHP 4.2.0
    function pg_query($Conn, $Sql)
    {
	return pg_exec($Conn, $Sql);
    }
}

    // As of PHP 5. This function is adapted from code posted by
    // info@pommef.com at
    // http://www.php.net/manual/en/function.str-split.php
if (! function_exists('str_split'))
{
    function str_split($String, $SplitLength=1)
    {
	$Count = strlen($String);
	for ($I = 0 ; $I < $Count ; $I += $SplitLength)
	    $Result[]= substr($String, $I, $SplitLength);   
	return $Result;
    }
}

?>