<?php
/*********************************************************************
gk_validate.php

Login Validation for PHP Service
______________________________________________________________________
Copyright 2015 Theodore B. Ruegsegger
This file is part of the GAPP Kit.

The GAPP Kit is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

The GAPP Kit is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with the GAPP Kit. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

*********************************************************************/
//********************************************************************
require ('lib_crypto.php');

// Fetch input variables
$FormVarList = array(
    "ForceNewPasswd"
);
$GetVarList = array(
    "ChangePassword",
    "ForceNewPasswd"
);
$PostVarList = array(
    "ChangePassword",
    "ForceNewPasswd",
    "NewPassword",
    "Password",
    "SavedStateAtTimeOut",
    "VerPassword"
);
foreach ($GetVarList as $Var)
    if (isset($_GET[$Var])) $$Var = trim($_GET[$Var]);
foreach ($PostVarList as $Var)
    if (isset($_POST[$Var])) $$Var = trim($_POST[$Var]);
$FormVars = (FormMethod == "get") ? $_GET : $_POST;
foreach ($FormVarList as $Var)
    if (isset($FormVars[$Var])) $$Var = trim($FormVars[$Var]);

if (isset($ChangePassword) or isset($ForceNewPasswd))
{
    // Password change. Validate current password:
    if (!IsPasswordValid ($_SESSION["UserRec"], $Password))
    {
        $BadPasswd = True;
        include ('gk/gk_changepw.php');
        exit;
    } elseif ($NewPassword == $Password)
      {
          $Unchanged = True;
          include ('gk/gk_changepw.php');
          exit;
      } elseif ($NewPassword != $VerPassword)
        {
            $BadVerify = True;
            include ('gk/gk_changepw.php');
            exit;
        } elseif (!PasswordLegal($NewPassword))
          {
              $Illegal = True;
              include ('gk/gk_changepw.php');
              exit;
          } else
            {
                $UserId = $_SESSION["UserRec"]["userid"];
                $NewCypherText = Encrypted($NewPassword);
                $Q = "UPDATE reguser SET";
                $Q .= " passwd_hash = $1,";
                $Q .= " passwd_changed = CURRENT_DATE";
                $Q .= " WHERE userid = $2";
                $U = Query ($Q, $NewCypherText, $UserId);
                if ($U)
                {
                    // Refresh user record
                    $Q = "SELECT r.userid, r.passwd_hash, r.passwd_changed,";
                    $Q .= " r.personsn, p.*";
                    $Q .= " FROM reguser r, person p";
                    $Q .= " WHERE r.userid = $1";
                    $Q .= " AND p.personsn = r.personsn";
                    $_SESSION["UserRec"]
                        = pg_fetch_array(Query($Q, $UserId), 0);
                    $PasswordChanged = True;
                    return;
                } else
                {
                    $PasswordChanged = False;
                    include ('gk/gk_changepw.php');
                    exit;
                }
            }
} else
{
    // retrieve the user record corresponding to userid
    $UserId = $_POST["UserId"];
    $Q = "SELECT r.userid, r.passwd_hash, r.passwd_changed,";
    $Q .= " r.personsn, p.*";
    $Q .= " FROM reguser r, person p";
    $Q .= " WHERE r.userid = $1";
    $Q .= " AND p.personsn = r.personsn";
    $U = Query($Q, $UserId);
    if (!$U)
    {
        $BadLogin=True;
        return;
    } elseif (pg_num_rows($U) < 1)
      {
          $BadLogin=True;
          return;
      } else
        {
            // User exists. Validate password:
            $Res = pg_fetch_array($U, 0);
            if (!IsPasswordValid($Res, $Password))
            {
                $BadLogin=True;
                return;
            } else
            {
                $_SESSION["UserRec"] = $Res;
                // Force change if default password:
                if ($_SESSION["UserRec"]["passwd_hash"]
                    == DefaultPwIndicator)
                {
                    $ForceNewPasswd = True;
                    include ('gk/gk_changepw.php');
                    exit;
                } else
                {
                    // Password valid. Check password age:
                    $Q = "SELECT coalesce(";
                    $Q .= " extract(day from CURRENT_DATE";
                    $Q .= " - passwd_changed), ";
                    $Q .= (PasswordLifeDays + 1);
                    $Q .= ") FROM reguser WHERE userid = $1";
                    $PasswordAge
                        = pg_fetch_result(Query($Q, $UserId), 0, 0);
                    if ($PasswordAge >= PasswordLifeDays)
                    {
                        $ForceNewPasswd = True;
                        include ('gk/gk_changepw.php');
                        exit;
                    } else
                    {
                        $PasswordDying =
                                       ($PasswordAge >= PasswordWarnDays)
                                       ? PasswordLifeDays - $PasswordAge : False;
                        if ($PasswordDying)
                        {
                            include ('gk/gk_changepw.php');
                            exit;
                        }
                        if (isset($SavedStateAtTimeOut))
                        {
                            $StateAtTimeOut
                                = ArrayUnpack($SavedStateAtTimeOut);
                            if (is_array($StateAtTimeOut))
                            {
                                // Restore form inputs
                                $_GET = $StateAtTimeOut["_GET"];
                                $_POST = $StateAtTimeOut["_POST"];
                                $_REQUEST = $StateAtTimeOut["_REQUEST"];
                                $CalledScript
                                    = $StateAtTimeOut["CalledScript"];
                                $_SERVER["SCRIPT_NAME"] = $CalledScript;
                                BounceStrangers(LoggedInUser(),
                                                $CalledScript);
                                include($CalledScript);
                                exit;
                            }
                        }
                        return;
                    }
                }
            }
        }
}

?>
