<?php
/****************************************************************
lib_graphicsmagick.php
GraphicsMagick Access Operations for PhotoTrove
______________________________________________________________________
Copyright 2014 Theodore B. Ruegsegger
This file is part of the PhotoTrove web application.

PhotoTrove is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

PhotoTrove is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________

****************************************************************/
// Functions

function Resize($Length, $FileName, $FullFolder, $DestFolder)
{
    /* Puts a $Length-sized copy of $FullFolder/$FileName into
     * $DestFolder, returns dimensions */
    return ResizePath($Length, "$FullFolder/$FileName",
		      "$DestFolder/$FileName");
}

function ResizePath($Length, $FullPath, $DestPath)
{
    /* Puts a $Length-sized copy of $FullPath at $DestPath, returns
     * dimensions */
    $Cmd = "gm convert -size ${Length}x${Length}";
    $Cmd .= " $FullPath -resize ${Length}x${Length}";
    $Cmd .= " $DestPath";
    shell_exec($Cmd);
    return Geometry ("$DestPath");
}

function RotatedSize($Image, $Rotation)
{
    // Rotates $Image $Rotation degrees, returns updated dimensions
    $Rot = 'gm mogrify -rotate '.$Rotation.' '.$Image;
    $Rotate = shell_exec ($Rot);
    return Geometry ($Image);
}

?>
