<?php
/*********************************************************************
lib_reports.php

Application-specific definitions for report generation
______________________________________________________________________
Copyright 2014 Theodore B. Ruegsegger
This file is part of the PhotoTrove web application.

PhotoTrove is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PhotoTrove is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with PhotoTrove. If not, see <http://www.gnu.org/licenses/>.
______________________________________________________________________
*********************************************************************/
require ("gk/gk_reports.php");

function FormSelectReport($ReportName
/*********************************************************************
This function allows convenient switching among the reports without
going back to a menu page.
Here, add other selection variables used by reports in the
application, for example:
, $DateStart, $DateEnd
*********************************************************************/
)
{
    $S = StrFormBegin("selectreport.php");
    $S .= StrTableBegin(0);
    $S .= StrRowBegin();
    $S .= StrCell(Strong("Report: "));
    $S .= StrCell(MenuAllowedReports($ReportName));
/*********************************************************************
Here, arrange the widgets for the other variables used by reports in
the application, for example:
    $S .= StrCell(Strong("From: "));
    $S .= StrCell(DateInput("DateStart", 10, StrDate($DateStart,
						     CalFormat)));
    $S .= StrCell(Strong("To: "));
    $S .= StrCell(DateInput("DateEnd", 10, StrDate($DateEnd,
						   CalFormat)));
*********************************************************************/
    $S .= StrRowEnd();
    $S .= StrTableEnd();
    $S .= StrFormEnd();
    return $S;
}

function ReportPageTitle($ExtraTags="", $ForceTitle=False)
{
    // A handy page-starting function for typical applications; for
    // non-typical applications, edit to suit.
    global $SystemTitle;
    $T = $ForceTitle ? $ForceTitle : ThisReportDescription();
    $S = HeadAndTitle("$T: $SystemTitle", $ExtraTags);
    $S .= PageTitleWithButton($T, BtnMainMenu());
    $S .= "<div align=\"center\">\n";
    return $S;
}

?>