<?php
/*********************************************************************
loc_crypto.php
Local Crypto Definitions for PHP Scripts

As distributed, assumes (edit if assumptions are wrong):
    o Default (initial) password is "lastname" value (lowercase)
    o System forces user to change password when logging in with
      default password

*********************************************************************/
define ("AllowDefaultPasswords", True);	// Set false to disable
define ("DefaultPwIndicator", "*");	// Shows no password set

// Password aging:
define ("PasswordLifeDays", 90);	// Timeout period, days
define ("PasswordWarnDays", 81);	// Pre-timeout warning, days
$T = "New password must be at least 8 characters, at least one of";
$T .= " which is not a letter.";
define ("LegalPasswordMsg", $T);

function DefaultCyphertext($UserRec)
{
    // Returns a weak password based on personal data, encrypted
    // Must force password change at first login
    return Encrypted (strtolower($UserRec["lastname"]));
}

function PasswordLegal ($Password)
{
    // Qualifies new passwords
    return (trim($Password) != '' and strlen($Password) > 7
	    and preg_match ("/[[:^alpha:]]/", $Password) );
}

?>
